//          Yasuharu Okamoto, 2020.04
data {
    int N;		//	The number of trials
    int Res[N];		//	Responses:  1 denotes -, 2 denotes ?, 3 denotes +
    real X[N];		//	Stimuli
    real a;             //      Parameter alpha of a gamma distribution for the prior distribution
    real b;             //      Parameter beta of a gamma distribution for the prior distribution
}

parameters {
    real<lower = 0.0> sgm;
    real mu;
    real<lower = 0.0> C;
}

transformed parameters {
    vector[3] p[N];		//	Probabilities for X[N]
    for (i in 1:N){
        p[i][1] = 1 - Phi((X[i] - mu + C) / sgm);
        p[i][2] = Phi((X[i] - mu + C) / sgm) - Phi((X[i] - mu - C) / sgm);
        p[i][3] = Phi((X[i] - mu - C) / sgm);
    }
}

model {
    sgm ~ gamma(a, b);
    mu ~ gamma(a, b);
    C ~ gamma(a, b);
    for (i in 1:N)
        Res[i] ~ categorical(p[i]);
}
